unit AspiAnwendung;
interface
uses wnaspi32,classes,sysutils,windows;


//Bodyfunctions of Program MotorAus. Demonstrates usage of Wnaspi32
//Drives collected in DiskDrives (TList-Object) are accessible.
//feel free to take this as example for your ASPI-app.

Type PDiskDevices=^DiskDevices;
     DiskDevices=record
       HA,ID,LUN:word;
       Name:string;
     end;

var DiskDrives:TList;

function GetDiskDeviceInfos(Protokoll:TStrings):boolean;
function StartStopUnit(Start:boolean;P:PDiskDevices):boolean;

implementation

type PSRBBuf=^SRBBuf;
     SRBBuf=array [0..1000] of Byte;

const DevTypes:array[0..9] of String=
         ('Disk Device','Tape Device','Printer','Prozessor','WriteOnce Device',
          'CD-ROM Device','Scanner','Otical Memory','Medium Changer',
          'Comunication Device');

//PSRBBuf is a Databuffer for SCSI-Commands e.g. the Buffer for a Sectorread
procedure InitSRB(P:Pointer;Len:word);
 var i:word;
     Pt:PSRBBuf;
 begin
   Pt:=P;
   for i:=0 to Len-1 do Pt^[i]:=0;
 end;


function GetDiskVendor(P:PDiskDevices):boolean;
 var Buffer:PSRBBuf;
     SRB:PSRB_ExecSCSICmd;
     i:integer;
 begin
   SRB:=New(PSRB_ExecSCSICmd);
   Buffer:=New(PSRBBuf);
   InitSRB(SRB,sizeOf(SRB^));
   SRB^.SRB_CMD:=SC_EXEC_SCSI_CMD;
   SRB^.SRB_Flags:=8;
   SRB^.SRB_HAId:=P^.HA;
   SRB^.SRB_Target:=P^.ID;
   SRB^.SRB_Lun:=0;
   SRB^.SRB_BufPointer:=Buffer;
   SRB^.SRB_Buflen:=36;
   SRB^.SRB_SenseLen:=14;
   SRB^.SRB_CDBLen:=6;
   SRB^.CDBByte[0]:=$12;
   SRB^.CDBByte[1]:=P^.Lun*32;
   SRB^.CDBByte[4]:=36; {Length of SCSI-command}
   SendASPI32Command(SRB);
   while SRB^.SRB_Status=0 do;
   if SRB^.SRB_Status=1
     then begin
       P^.Name:='';
       for i:=8 to 15 do
        if buffer[i]=0 then Break
                       else P^.Name:=P^.Name+char(Buffer[i]);
       P^.Name:=P^.Name+' ';
       for i:=16 to 31 do
        if buffer[i]=0 then Break
                       else P^.Name:=P^.Name+char(Buffer[i]);


       GetDiskVendor:=true;
     end
     else GetDiskVendor:=false;
   dispose(SRB);
   dispose(Buffer);
 end;

function StartStopUnit(Start:boolean;P:PDiskDevices):boolean;
 var SRB:PSRB_ExecSCSICmd;
 begin
   SRB:=New(PSRB_ExecSCSICmd);
   InitSRB(SRB,sizeOf(SRB^));
   SRB^.SRB_CMD:=SC_EXEC_SCSI_CMD;
   SRB^.SRB_Flags:=0;
   SRB^.SRB_HAId:=P^.HA;
   SRB^.SRB_Target:=P^.ID;
   SRB^.SRB_Lun:=0;
   SRB^.SRB_BufPointer:=nil;
   SRB^.SRB_Buflen:=0;
   SRB^.SRB_SenseLen:=14;
   SRB^.SRB_CDBLen:=6;
   SRB^.CDBByte[0]:=$1B;
   SRB^.CDBByte[1]:=P^.Lun*32;
   if Start then SRB^.CDBByte[4]:=1;
   SendASPI32Command(SRB);
   while SRB^.SRB_Status=0 do;
   StartStopUnit:=true;
end;

function GetDiskDeviceInfos(Protokoll:TStrings):boolean;
   VAR NumAdap:Longint;
    HA_Num,ID,j:integer;
    s:String;
    InqSRB:PSRB_HAInquiry;
    DeTSRB:PSRB_GDEVBlock;
    AktDisk:PDiskDevices;
  begin
    DiskDrives:=TList.Create;
    GetDiskDeviceInfos:=false;
    //initialise ASPI-mgr.
    NumAdap:=GetAspi32SupportInfo;
    if HiByte(LoWord(NumAdap))<>SS_COMP
      then begin
        Protokoll.add('SCSI-Manager not available (perhaps not installed?)');
        exit;
      end;
    InqSRB:=new(PSRB_HAInquiry);
    InitSRB(InqSRB,sizeOf(InqSRB^));
    DetSRB:=New(PSRB_GDEVBlock);
    InitSRB(DetSRB,sizeOf(DetSRB^));
    NumAdap:=NumAdap and 255;
    for HA_Num:=0 to NumAdap-1 do
      begin
        //With hostadapter-inquiry successive ask all of then
        //At existing hostadapter with TestUnitReady
        //shake all IDs. LUN=0 is expected. Restrition applys to RAID-Servers
        InqSrb^.SRB_Cmd:= 0;
        InqSrb^.SRB_HaId:= HA_Num;
        InqSrb^.SRB_Flags:= 0;
        SendASPI32Command(InqSrb);
        while InqSrb^.SRB_Status=0 do;
        if InqSrb^.SRB_Status = $81
           then Protokoll.add(format('ASPI Error at Hostadapter %d',[HA_Num]))
           else begin {Read Hostadapter-Name}
             s:='';
             for j:=0 to 15 do
               if(InqSrb^.HA_Identifier[j]=0)
                 then break
                 else s:=s+char(InqSrb^.HA_Identifier[j]);
             Protokoll.add(format('Hostadapter '+s+
                                   ' AspiNum: %d, SCSI-ID: %d',
                                   [HA_Num,InqSrb^.HA_SCSI_ID]));
             //search Drives of this Hostadpters
             for ID:=0 to 7 do
               begin
                 DetSrb^.SRB_CMD:=SC_Get_Dev_Type;
                 DetSrb^.SRB_HaId:= HA_Num;
                 DetSrb^.SRB_Flags:= 0;
                 DetSrb^.SRB_Target:=ID;
                 DetSrb^.SRB_Lun:=0;
                 SendASPI32Command(DetSrb);
                 while DetSrb^.SRB_Status=0 do;
                 if DetSrb^.SRB_Status = 1
                   then begin
                     j:=DetSrb^.SRB_DeviceType;
                     if j in [0..9]
                       then s:=DevTypes[j] else s:='';
                     Protokoll.add(format('   Device ID %d vom Typ %d='+s,[ID,j]));
                     if j=0 then
                      begin //DISK-Device. get vendor.
                        AktDisk:=New(PDiskDevices);
                        AktDisk^.HA:=HA_Num;AktDisk^.ID:=ID;AktDisk^.Lun:=0;
                        if GetDiskVendor(AktDisk)
                           then begin
                             DiskDrives.Add(AktDisk);
                             Protokoll.add('      Devicename:'+AktDisk^.Name);
                           end
                           else begin
                             dispose(AktDisk);
                             Protokoll.Add('  Inquiry failed..??');
                           end;
                      end;
                   end;
               end;
           end;
      end;
    dispose(InqSRB);
    dispose(detSRB);
  end;

end.
